﻿using System;
using System.Xml;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Configuration;

namespace CodeEffects.Rule.Demo.Asp.Common.Controls
{
	public partial class Site : MasterPage
	{
		protected override void OnLoad(EventArgs e)
		{
			base.OnLoad(e);

			this.InitNavigation();
		}

		private void InitNavigation()
		{
			string url = HttpContext.Current.Request.Url.LocalPath;
			if(string.IsNullOrEmpty(url)) url = HttpContext.Current.Request.Url.AbsolutePath;
			if(url != null) url = url.ToLower();

			XmlDocument navigation = new XmlDocument();
			navigation.Load(Server.MapPath(ConfigurationManager.AppSettings["NavigationConfigFile"]));

			foreach(XmlNode page in navigation.DocumentElement.SelectSingleNode("/codeeffects/pages").ChildNodes)
			{
				if(page.NodeType == XmlNodeType.Comment) continue;
				if((url == null || url == "/") && page.Attributes["initial"] != null && page.Attributes["initial"].Value == "true") this.WriteSpan(page);
				else if(url.StartsWith(page.Attributes["url"].Value, StringComparison.OrdinalIgnoreCase)) this.WriteSpan(page);
				else this.WriteAnchor(page);
			}
		}
		private void WriteSpan(XmlNode page)
		{
			HtmlGenericControl spn = new HtmlGenericControl("span");
			spn.InnerText = page.Attributes["text"].Value;
			spn.Attributes["class"] = "selectedNav";
			this.divNav.Controls.Add(spn);
		}
		private void WriteAnchor(XmlNode page)
		{
			HtmlAnchor a = new HtmlAnchor();
			a.HRef = page.Attributes["url"].Value;
			a.InnerText = page.Attributes["text"].Value;
			a.Attributes["class"] = "nav";
			this.divNav.Controls.Add(a);
		}
	}
}